<?php
/*
Plugin Name: InflatableOffice WP Integration
Plugin URI: https://rental.software
Description: Integrates your InflatableOffice inventory into your wordpress site to generate and keep updated products and categories.
Author: InflatableOffice
Author URI: https://rental.software
Version: 6.11.12
*/
$plugin_current_version = '6.11.12';//also set it above in the comments
require_once('shortcoder.php');
require_once('wp-oauth.php');
//require_once('wp-rest-api.php');
require_once ('wp_autoupdate.php');
require_once ('widget-featured.php');
require_once ('widget-filter.php');
require_once ('widget-TentCalc.php');
require_once ('search_widget/includes/class-widget.php');
require_once ('search_widget/searchio-live-ajax-search.php');

$plugin_remote_path = 'https://rental.software/wp-plugin/update.php';
$plugin_slug = 'inflatableoffice/inflatableoffice.php';
//$license_user = 'user';
//$license_key = 'abcd';
new IOWP_AutoUpdate ( $plugin_current_version, $plugin_remote_path, $plugin_slug);//, $license_user, $license_key );

function inoff_setup($network_wide){
    if(is_user_logged_in()) {
        _wo_server_activation($network_wide);
        $wo = new WO_Server();
        $wo->setup();
        $wo->upgrade();
        //json_api_activation(false);
        sc_setup();

        //flush_rewrite_rules();//force permalink refresh which is needed due to api update

        if (!get_option('io_checkavail')) update_option("io_checkavail", 'warn');//default

        //create pages for quote integration
        create_io_pages();//running it every page load now as well as on plugin activation (bc if they switch themes we have to re-activate to create the pages)
    }
}

register_activation_hook( __FILE__, 'inoff_setup' );


function io_check_plugin_version() {
    if( !function_exists('get_plugin_data') ){
        require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
    }
    $current_version = get_plugin_data( (__FILE__) )['Version'];
    $old_version = get_option( 'io_plugin_version' );
    if(empty($old_version)) $old_version= 0;
    if (version_compare($current_version,$old_version,'>')) {
        //this code only runs 1x after plug-in is upgraded
        //sc_setup();//below so it runs all the time...
        // flush_rewrite_rules();
        add_action("shutdown", "flush_rewrite_rules");

        //check shortcodes to make sure all are set to auto-upgade for this version
        if (version_compare($old_version,'4.0.0','<')) {
            $autoupdate=1;
            $shortcoder_data = get_option('shortcoder_data');
            if (!empty($shortcoder_data)) {
                foreach ($shortcoder_data as $k => $v) {
                    if (empty($shortcoder_data[$k]['autoupdate']) && $k<>'io_category' && $k<>'io_categroy') {
                        $autoupdate=0;
                    }
                }
                if($autoupdate==0) {
                    foreach ($shortcoder_data as $k => $v) {
                        $shortcoder_data[$k]['autoupdate'] = 0;
                    }
                    update_option('shortcoder_data', $shortcoder_data);
                }
            }
        }
        // remove this page, as changes may have been made to it.
        if(file_exists(get_template_directory().'/page-io_reviews.php')){
            unlink(get_template_directory().'/page-io_reviews.php');
        }

        // update not to run twice
        update_option('io_plugin_version', $current_version);
    }
}
io_check_plugin_version();

function unhash_login() {
    if (isset($_REQUEST['io_auth']) && !is_user_logged_in()) {
        $key = 'cGSmuRB/EB6P5ylv"mk!';
        $encrypted = urldecode($_REQUEST['io_auth']);
        $decrypted = base64_decode($encrypted);
        $plaintext = str_replace($key, '', $decrypted);
        $credentials = explode('&', $plaintext, 2);

        if (empty($credentials[0]) || empty($credentials[1])) {
            wp_mail("dan@inflatableoffice.com", "Unhash Login Error", "Decryption failed or incomplete credentials");
            return;
        }

        auto_login_temp($credentials[0], $credentials[1]);
    }
}
add_action('init', 'unhash_login');

function auto_login_temp($u, $p) {
    if (!is_user_logged_in()) {
        $user = get_user_by('login', $u);
        if (!$user) {
            wp_mail("dan@inflatableoffice.com", "Auto Login Temp Error", "User not found with username - {$u}");
            return;
        }

        if (!wp_check_password($p, $user->data->user_pass, $user->ID)) {
            wp_mail("dan@inflatableoffice.com", "Auto Login Temp Error", "Password check failed for user - {$u}");
            return; // Incorrect password
        }

        $loginusername = $user->user_login;
        wp_set_current_user($user->ID, $loginusername);
        wp_set_auth_cookie($user->ID, true);
        do_action('wp_login', $loginusername, $user);

        // Redirect after login
        if (isset($_REQUEST['redirect_to'])) {
            $redirect_page = $_REQUEST['redirect_to'];
        } else {
            $redirect_page = admin_url();
        }

        wp_redirect($redirect_page);
        exit();
    }
}

function extend_login_sessions($expire) {
    // Set the expiration to 30 days (30 days * 24 hours * 60 minutes * 60 seconds)
    return 90 * 24 * 3600;
}
add_filter('auth_cookie_expiration', 'extend_login_sessions');

// Fixes shortcode update issue
sc_setup();

// Fixes multisite activation issue. #14422
add_action('init', 'inoff_setup');

//can probably remove this eventually
//add_action( 'shutdown', 'flush_rewrite_rules');//force permalink refresh which is needed due to api update

function widget_featured() {
    register_widget( 'IO_Featured' );

}
add_action( 'widgets_init', 'widget_featured');

function widget_filter() {
    register_widget( 'Widget_Filter' );

}
add_action( 'widgets_init', 'widget_filter' );

function widget_TentCalculator() {
    register_widget( 'Widget_TentCalculator' );

}
add_action( 'widgets_init', 'widget_TentCalculator');

function searchio_live_search() {
    register_widget( 'IO_Search' );

}
add_action( 'widgets_init', 'searchio_live_search' );

//removes wrong p tags that are added to descr, but didn't solve
/*add_filter('the_content', 'test_cont','10.1');
function test_cont($content) {
    $content = str_replace(' description="</p>',' description="',$content);
    $content = str_replace('<p>" notes=','" notes=',$content);
    return $content;
};*/

//links are verified externally. removing them will only delist your links
function get_io_links(){
    $links = get_option( 'io_links' );
    $links_obj = json_decode($links);
    echo get_header();
    echo "<br><br><br>";
    echo '<h2>Other great rental companies</h2>';
    foreach($links_obj as $item){
        echo $item."<br><br>";
    }
    echo get_footer();
}

function create_io_pages(){

    if(!file_exists(get_template_directory().'/page-io_quoteform.php')) file_put_contents ( get_template_directory().'/page-io_quoteform.php' , '<?php $page_type = \'quoteme\'; require_once(get_template_directory() . \'/../../plugins/inflatableoffice/io-getpagecontent.php\'); ?>');
    /*file_put_contents ( get_template_directory().'/page-io_quoteform.php' , '<?php $page_type = \'quoteme\'; require_once(\'/var/www/wp/wp-content/plugins/inflatableoffice/io-getpagecontent.php\'); ?>');*/
    /* jpa - dev  note: switch line above. don't use //.  change $base_qt_url in io-getpagecontent */
    $page = get_page_by_path( 'io_quoteform' , OBJECT );
    if(empty($page)) $id = wp_insert_post(array('post_title'=>'Quote Form','post_name'=>'io_quoteform', 'post_type'=>'page', 'post_status'=>'publish','post_content'=>'Do not delete. This page\'s content is generated.'));

    if(!file_exists(get_template_directory().'/page-io_quoteconfirm.php')) file_put_contents ( get_template_directory().'/page-io_quoteconfirm.php' , '<?php $page_type = \'quote_confirm\'; require_once(get_template_directory() . \'/../../plugins/inflatableoffice/io-getpagecontent.php\'); ?>');
    $page = get_page_by_path( 'io_quoteconfirm' , OBJECT );
    if(empty($page)) $id = wp_insert_post(array('post_title'=>'Quote Details','post_name'=>'io_quoteconfirm', 'post_type'=>'page', 'post_status'=>'publish','post_content'=>'Do not delete. This page\'s content is generated.'));

    if(!file_exists(get_template_directory().'/page-io_contract.php')) file_put_contents ( get_template_directory().'/page-io_contract.php' , '<?php $page_type = \'contractme\'; require_once(get_template_directory() . \'/../../plugins/inflatableoffice/io-getpagecontent.php\'); ?>');
    $page = get_page_by_path( 'io_contract' , OBJECT );
    if(empty($page)) $id = wp_insert_post(array('post_title'=>'Event Contract','post_name'=>'io_contract', 'post_type'=>'page', 'post_status'=>'publish','post_content'=>'Do not delete. This page\'s content is generated.'));

    if(!file_exists(get_template_directory().'/page-io_contactform.php')) file_put_contents ( get_template_directory().'/page-io_contactform.php' , '<?php $page_type = \'contactme\'; require_once(get_template_directory() . \'/../../plugins/inflatableoffice/io-getpagecontent.php\'); ?>');
    $page = get_page_by_path( 'io_contactform' , OBJECT );
    if(empty($page)) $id = wp_insert_post(array('post_title'=>'Contact Us','post_name'=>'io_contactform', 'post_type'=>'page', 'post_status'=>'publish','post_content'=>'Do not delete. This page\'s content is generated.'));

    if(!file_exists(get_template_directory().'/page-io_receipt.php')) file_put_contents ( get_template_directory().'/page-io_receipt.php' , '<?php $page_type = \'receipt\'; require_once(get_template_directory() . \'/../../plugins/inflatableoffice/io-getpagecontent.php\'); ?>');
    $page = get_page_by_path( 'io_receipt' , OBJECT );
    if(empty($page)) $id = wp_insert_post(array('post_title'=>'Payment Receipt','post_name'=>'io_receipt', 'post_type'=>'page', 'post_status'=>'publish','post_content'=>'Do not delete. This page\'s content is generated.'));

    if(!file_exists(get_template_directory().'/page-io_vendor.php')) file_put_contents ( get_template_directory().'/page-io_vendor.php' , '<?php $page_type = \'vendorme\'; require_once(get_template_directory() . \'/../../plugins/inflatableoffice/io-getpagecontent.php\'); ?>');
    $page = get_page_by_path( 'io_vendor' , OBJECT );
    if(empty($page)) $id = wp_insert_post(array('post_title'=>'Vendor Contract','post_name'=>'io_vendor', 'post_type'=>'page', 'post_status'=>'publish','post_content'=>'Do not delete. This page\'s content is generated.'));

    if(!file_exists(get_template_directory().'/page-io_quotedone.php')) file_put_contents ( get_template_directory().'/page-io_quotedone.php' , '<?php $page_type = \'quote_done\'; require_once(get_template_directory() . \'/../../plugins/inflatableoffice/io-getpagecontent.php\'); ?>');
    $page = get_page_by_path( 'io_quotedone' , OBJECT );
    if(empty($page)) $id = wp_insert_post(array('post_title'=>'Quote Done','post_name'=>'io_quotedone', 'post_type'=>'page', 'post_status'=>'publish','post_content'=>'Do not delete. This page\'s content is generated.'));

    /*if(!file_exists(get_template_directory().'/page-io_links.php')) file_put_contents ( get_template_directory().'/page-io_links.php' , '<?php echo get_io_links(); ?>');
    $page = get_page_by_path( 'io_links' , OBJECT );
    if(empty($page)) $id = wp_insert_post(array('post_title'=>'Friends','post_name'=>'io_links', 'post_type'=>'page', 'post_status'=>'publish','post_content'=>'Do not delete. This page\'s content is generated.'));
    */


    $theme = wp_get_theme();


    $review_page_output = '<?php

        get_header(); ?>
        
            <div class="welcome-wrap inner_warpper" id="main-content">
                <div class="container">
                    <div class="welcome-inner">
                        <header><h1 class="heading1">Reviews</h1></header>
                        <!-- Start InflatableOffice Testimonials Widget-->
                        <div id="io_testimonials"></div>
                        <a title="party rental software" href="https://www.inflatableoffice.com" target="_blank" rel="noopener"><img id="ioimg" style="border: 0; margin-top: -12px;" src="https://rental.software/images/party_rental_software.png" alt="party rental software" /></a>
                        <!-- End InflatableOffice Testimonials Widget -->
        
                    </div>
                </div>
            </div>
            <div class="inner_content_wrapper">
            </div>
            <style>
		        iframe#ioi_testimonials_iframe {
			        margin: auto;
			        margin-top: 0px;
                }
                img#ioimg {
                    display: block;
                    margin: auto;
                    margin-bottom: 10px;
                }
	        </style>';


    if($theme=='IO-Kenos') {
        $review_page_output = '
		<?php

        get_header(); ?>
        
        <div class="welcome-wrap" id="main-content">
            <div class="container io_sc_container">
                <div class="welcome io_sc_welcome">
                    <br><div class="ribbon"><h3>Reviews</h3></div><br>
					<div class="testi_wrapper">
	<div id="io_testimonials"></div>
	</div>

    <div class="btm-sec">
    
    
    <?php get_footer(); ?>
    ';
    }

    if($theme=='Create' || $theme=='IO-Premium' || $theme=="IO-Kenos") {
        $review_page_output = $review_page_output . '
        <style>

        .io_sc_welcome .ribbon {
            display: block;
            width: 65vw;
            margin: auto;
        }
    
        iframe {
            display: block;
            margin: auto;
            width: 65vw;
        }

        @media screen and (max-width: 500px) {
            iframe {
                width: 85vw;
            }
        }
        
    </style>';
    };

    $review_page_output = $review_page_output . '
    <div class="btm-sec">
    
    
    <?php get_footer(); ?>
    ';
    if(!file_exists(get_template_directory().'/page-io_reviews.php')) file_put_contents ( get_template_directory().'/page-io_reviews.php' , $review_page_output);
    $page = get_page_by_path( 'io_reviews' , OBJECT );
    if(empty($page)) $id = wp_insert_post(array('post_title'=>'Reviews','post_name'=>'io_reviews', 'post_type'=>'page', 'post_status'=>'publish','post_content'=>'Do not delete. This page\'s content is generated.'));

}

if(strpos($_SERVER['REQUEST_URI'],'io_')!==FALSE) create_io_pages();

// #5474 - add adwords tracking
// #6028 - add facebook tracking
function io_analytics_tracking() {
    if(array_key_exists('gclid',$_REQUEST)) {
        $gclid = empty($_REQUEST['gclid']) ? 1 : $_REQUEST['gclid'];
        setcookie("adwords", $gclid, time() + 3600*24*30,'/');
    }
    if(array_key_exists('fbclid',$_REQUEST)) {
        $fbclid = empty($_REQUEST['fbclid']) ? 1 : $_REQUEST['fbclid'];
        setcookie("facebook", $fbclid, time() + 3600*24*30,'/');
    }
}
add_action( 'init', 'io_analytics_tracking' );

add_action( 'wp_footer', 'io_addtracking_allpages' );
function io_addtracking_allpages() {
    if(strpos(get_site_url(), 'localhost') !== false){
        $html = '<img src="http://localhost/io/bugs/include/iotracking.php" style="display:none;" importance="low" alt="dynamic io trk code" />';
    }else{
        $html = '<img src="https://rental.software/include/iotracking.php" style="display:none;" importance="low" alt="dynamic io trk code" />';
    }
    echo $html;
}
if(get_option('io_username')<>'inflatableoffice'){
    add_action( 'wp_footer', 'io_add_code_allpages' );
}
function set_custom_referrer_policy() {
    header('Referrer-Policy: no-referrer-when-downgrade');
}
add_action('send_headers', 'set_custom_referrer_policy');

function io_add_code_allpages(){

    $showCategoryLong = get_option('io_showCategoryLong');
    $showCategoryLong_css = '';
    if($showCategoryLong && $showCategoryLong =='off'){
        $showCategoryLong_css = '.io_cat_longdescription{display:none !important;}';
    }

    $io_hidetimes = get_option('io_hidetimes');
    $hidetimes_css = '';
    if($io_hidetimes=='on'){
        $hidetimes_css = "#cartTimePicker .timepicker,#cartTimePicker .fa-clock{display: none !important;}
        .ioCartCompanyTimeslots{display: none !important;}
        .calTimeLabel{display: none !important;}       
        #cartDateRange{margin-bottom: 10px;margin-left: 40px;font-size: x-large;}";
    }
    $io_checkavail = get_option('io_checkavail');
    $hide_checkavail_css = '';
    if($io_checkavail=='off'){
        $hide_checkavail_css = ".item-availability{display: none !important;}";
    }

    //hide price setting
    $hide_price_css = '';
    $io_hide_prices = get_option('io_hide_prices');
    if($io_hide_prices==1){
        $hide_price_css = "
        .rentNameIO_price, .io_product_price_box, .item-total, .cartSubtotalBox
        {
            display: none !important;
        }
        ";
    }

    //hide cat price setting
    $hide_price_catpages_css = '';
    $io_hide_prices_catpages = get_option('io_hide_prices_catpages');
    if($io_hide_prices_catpages==1){
        $hide_price_catpages_css = "
        .rentNameIO_price
        {
            display: none !important;
        }
        ";
    }

    //hide price setting
    $hide_live_price_css = '';
    $io_hide_live_prices = get_option('io_hide_live_prices');
    if($io_hide_live_prices==1 && get_option('io_always_display_live_price') != "on"){
        $hide_live_price_css = "
        .io_product_cust_price
        {
            display: none !important;
        }
        #item_live_price_time_set_message
        {
            display: none !important;
        }
        ";
    }

    //product page price settings
    //todo  master theme has settings on
    //todo mega menu choices (theme menu section)
    $price_override_css = '';
    $prices_css_hide_defaults = '';
    $prices_override_hide_css = '';
    $prices_default_product_page_css = '';
    $prices = get_option('io_prices');
    if(!empty($prices)) {
        //hide the defaults
        $prices_css_hide_defaults = '.io_product_price_4h,.io_product_price_8h,.io_product_price_24h,.io_product_price_additionalday{display:none}';
        //show these
        foreach ($prices as $v) {
            if(is_array($v)) continue;
            $split = explode('_', $v);
            if(isset($split[1])) {
                if (sizeof($split) == 4 && $split[1] == 'product' && $split[2] == 'price') {
                    $prices_default_product_page_css .= '.' . $v . ',';
                } else if(sizeof($split) == 5 && $split[1] == 'product' && $split[2] == 'price'){
                    $price_override_css .= '.' . $v . ',';
                }else if(sizeof($split) == 6 && $split[1] == 'product' && $split[2] == 'price'){
                    // IO-21808
                    $price_override_css .= '.' . $v . ',';
                }
            }
        }
        $prices_default_product_page_css = rtrim($prices_default_product_page_css, ',');
        $price_override_css = rtrim($price_override_css, ',');
        if (!empty($prices_default_product_page_css)) {
            $prices_default_product_page_css .= '{display: grid !important}';
        }
        if (!empty($price_override_css)) {
            $price_override_css .= '{display: grid !important}';
        }
        //for override prices, we must hide default pricing
        $prices_override_hide_css = '';
        foreach ($prices as $v) {
            if(is_array($v)) continue;
            $split = explode('_', $v);
            //for each default price
            if(!is_array($split)) continue;
            if (sizeof($split) == 4 && ($split[1] == 'product' || $split[1] == 'custom' || $split[1] == 'delivery')) {
                //for each override
                foreach ($prices as $ov) {
                    if(is_array($ov)) continue;
                    $osplit = explode('_', $ov);
                    if(!is_array($osplit)) continue;
                    if (sizeof($osplit) == 5 && ($split[1] == 'product' || $split[1] == 'custom' || $split[1] == 'delivery')) {
                        if (!in_array('io_product_price_' . $split[3] . '_' . $osplit[4], $prices)) {
                            $prices_override_hide_css .= '.io_product_price_' . $split[3] . '_' . $osplit[4].',';//disable it
                        }
                        //if 0h, hide on cat too
                        if($osplit[3]=="0h"){
                            $prices_override_hide_css .= '.rentNameIO_price_'.$osplit[4].',';
                        }
                    }
                }
            }
        }
        $prices_override_hide_css = rtrim($prices_override_hide_css, ',');
        if(!empty($prices_override_hide_css)){
            $prices_override_hide_css.='{display: none !important}';
        }
    }

    $LOCAL_PATH = get_bloginfo('url');
    $LOCAL_PATH = parse_url($LOCAL_PATH, PHP_URL_PATH);

    $timeslots = get_option('io_company_timeslots');
    if(empty($timeslots)) $timeslots = '""';//so js doesn't error below

    $delivery_methods = get_option('io_delivery_methods');
    if(empty($delivery_methods)) $delivery_methods = '""';//so js doesn't error below

    $io_delivery_prices_json = get_option('io_delivery_prices');
    if(!$io_delivery_prices_json || empty($io_delivery_prices_json)) {
        $io_delivery_prices_json = '{"default":[], "override":[]}';//so js doesn't error below
    }else{
        $io_delivery_prices_json = json_encode($io_delivery_prices_json);
    }

    $io_custom_prices_json = get_option('io_custom_prices');
    if(!$io_custom_prices_json || empty($io_custom_prices_json)) {
        $io_custom_prices_json = '{"default":[], "override":[]}';//so js doesn't error below
    }else{
        $io_custom_prices_json = json_encode($io_custom_prices_json);
    }

    $io_info_required_data_json = get_option('io_info_required_data');
    if(!$io_info_required_data_json || empty($io_info_required_data_json)) {
        $io_info_required_data_json = "[]";//so js doesn't error below
    }else{
        $io_info_required_data_json = json_encode($io_info_required_data_json);
    }

    $io_prices_json = json_encode(get_option('io_prices'));
    if(empty($io_prices_json)) $io_prices_json = "[]";//so js doesn't error below

    $delivery_methods_restrict = get_option('io_deliveryMethodRestrict');
    if(empty($delivery_methods_restrict)) $delivery_methods_restrict = '""';//so js doesn't error below

    $io_hideQuantityAvail = get_option('io_hideQuantityAvail');
    if(empty($io_hideQuantityAvail)) $io_hideQuantityAvail = "off";

    $io_hide_live_prices = get_option('io_hide_live_prices');
    if(empty($io_hide_live_prices)) $io_hide_live_prices = 1;

    $html = '
     <style>
     '.$prices_css_hide_defaults.$prices_default_product_page_css.$hide_price_css.$hide_price_catpages_css.$price_override_css.$prices_override_hide_css.$hide_checkavail_css.$hidetimes_css.$hide_live_price_css.$showCategoryLong_css.'
    .io_all_item_cat{
        display:none;
        float:none;
        width:100%;
        margin-top:20px;
    }
    </style>
    
    <script>
    var io_wp_local_path = "'.$LOCAL_PATH.'";
    var io_checkavail = "'.$io_checkavail.'";
    var io_hidetimes = "'.$io_hidetimes.'";
    var io_user_country = "'.get_option('io_user_country').'";
    var io_user_currency = "'.get_option('io_user_currency').'";
    var io_default_start_time = "'.get_option('io_default_start_time').'";
    var io_default_end_time = "'.get_option('io_default_end_time').'";
    var io_cart_date_format = "'.get_option('io_cart_date_format').'";
    var io_cart_message = "'.get_option('io_cartmessage').'";
    var io_cart_time_format = "'.get_option('io_cart_time_format').'";
    var io_multidayquote = "'.get_option('io_multidayquote').'";
    var io_cartdayselect = "'.get_option('io_cartdayselect').'";
    var io_cartAllowSameDay = "'.get_option('io_cartAllowSameDay').'";
    var io_overnightPickupTime = "'.get_option('io_overnightPickupTime').'";
    var io_incartupsell = "'.get_option('io_incartupsell').'";
    var io_distancecharge = "'.get_option('io_distancecharge').'";
    var io_deliverymethod = "'.get_option('io_deliverymethod').'";
    var io_brand = "'.get_option('io_brand').'";
    var io_restrict_times = "'.get_option('io_restricttimes').'";
    var io_restrict_time_start = "'.get_option('io_restrictTimeStart').'";
    var io_restrict_time_end = "'.get_option('io_restrictTimeEnd').'";
    var io_default_state = "'.get_option('io_default_state').'";
    var io_hide_zero = "'.get_option('io_hide_zero').'";
    var io_weekEndPrice = "'.get_option('io_weekEndPrice').'";
    var io_weekDayText = "'.get_option('io_weekDayText').'";
    var io_weekEndText = "'.get_option('io_weekEndText').'";
    var io_weekendDefine = "'.get_option('io_weekendDefine').'";
    var io_accessory_price = "'.get_option('io_accessory_price').'";
    var io_accessory_select = "'.get_option('io_accessoriesSelect').'";
    var io_upsell_price = "'.get_option('io_upsell_price').'";
    var io_cart_party_planner_email = "'.get_option('io_cartPartyPlannerEmail').'";
    var io_cart_party_planner_destination = "'.get_option('io_cartPartyPlannerDestination').'";
    var io_hideQuantityAvail = "'.$io_hideQuantityAvail.'";
    var io_company_timeslots = '.$timeslots.';
    var io_info_required = "'.get_option('io_info_required').'";
    var io_always_display_live_price = "'.get_option('io_always_display_live_price').'";
    var io_hide_live_prices = '.$io_hide_live_prices.';
    var io_info_required_data = '.$io_info_required_data_json.';
    var io_prices = '.$io_prices_json.';
    var io_delivery_prices = '.$io_delivery_prices_json.';
    var io_custom_prices = '.$io_custom_prices_json.';
    var io_delivery_methods = '.$delivery_methods.';
    var io_delivery_methods_restrict = '.$delivery_methods_restrict.';
    var io_pagename = "'.get_option('io_pagename').'";
    //var io_seocitylinktext = "'.get_option('io_seocitylinktext').'";
    jQuery( document ).ready(function() {
        
        //force all quote form links to use cart data
        //removing back to cart shortcode as this needs to only be done if cart is not empty IO-22561
        /*
        let headerBookButton = jQuery("a[href$=\'io_quoteform/\']");
        headerBookButton.addClass("ioCart_link");
        headerBookButton.attr("href", "javascript:;");
        */
    
        
        let last_cat_name = "";
        let ioTrigger = false;
        jQuery(".io_all_item_cat").each(function() {
            current_cat_name = jQuery(this).html();
            if(last_cat_name !== current_cat_name) {
                jQuery(this).show();
                ioTrigger = true;
            }
            last_cat_name = current_cat_name;
        });
        
        // Setup gen page blocks
		let io_divs = document.querySelectorAll(".io_item2_list, .io_item2_listcat, .io_item2_listrent, .io_all_item_cat");
		let io_divscat = document.querySelectorAll(".io_item2_listcat");
		let io_divsrent = document.querySelectorAll(".io_item2_listrent");
		let io_divcat = document.querySelector(".io_catdiv2");
		let io_pcc = document.querySelector(".page-content");
		let io_html;
		
		if (io_divs.length > 0) {
	      for (let i of io_divs) {
	        if(i.parentNode.className.indexOf("io_mm_") === -1){
	          io_divcat.appendChild(i);
	        }
		  }
		  if(io_divcat!==null) io_divcat.style.display = "grid";
		}
		
		if (ioTrigger) {
            let pageBlock = document.querySelector(".io_catdiv2");
            pageBlock.classList.add("elementor-widget-heading");
            let scanRes = pageBlock.querySelectorAll(".io_item2_listrent");
            pageBlock.style.display = "block";
            pageBlock.style.margin = "auto";
            pageBlock.style.textAlign = "center";
            pageBlock.style.marginLeft = "5px";
            pageBlock.style.marginRight = "5px";
            for (let i of scanRes) {
                i.style.display = "inline-block";
                i.style.marginLeft = "5px";
                i.style.marginRight = "5px";
            }
        }
		
		/* fix font color on older sites */
		if(jQuery("#cartData").css("background-color")=="rgb(35, 36, 37)"){
		    jQuery("#cartData").css("color","white");
		}
    });
  </script>';

    //add the cart code to all pages
    $html .= shortcoder(Array('io_cart','page'=>get_option('io_pagename')),'');

    //add the review code to all pages
    $html .= io_get_review_script();

    echo $html;
}

function io_get_review_script(){
    $show_all_reviews = get_option('io_showAllReviews');
    $number_of_reviews = '10';
    if($show_all_reviews && $show_all_reviews == 'off'){
        $number_of_reviews = get_option('io_reviewAmount');
    }else if($show_all_reviews && $show_all_reviews == 'on'){
        $number_of_reviews = 'all';
    }
    $show_average_rating = get_option('io_showAverageRating');
    $show_average_style = '';
    if($show_average_rating && $show_average_rating =='off'){
        $show_average_style = 'style="display:none"';
    }
    $show_review_stars = get_option('io_showReviewStars');
    if(!$show_review_stars){
        $show_review_stars = 'on';
    }
    $show_review_date = get_option('io_showReviewDate');
    $show_date_style = '';
    if($show_review_date && $show_review_date =='off'){
        $show_date_style = 'style="display:none"';
    }
    $show_reviewer_name = get_option('io_showReviewerName');
    $show_name_style = '';
    if($show_reviewer_name && $show_reviewer_name =='off'){
        $show_name_style = 'style="display:none"';
    }
    $review_order = 'time';
    if(get_option('io_reviewOrder')){
        $review_order = get_option('io_reviewOrder');
    }
    $html = '
        <script>
        jQuery(".io_testimonials, #io_testimonials").each(function(){
           io_get_reviews(this);
        })
        setTimeout(function(){
            jQuery(".io_testimonials .w3-ul li p").each(function(){
                const container = jQuery(this).parent()
                const element = jQuery(this);
                
                if (element[0].scrollHeight > container[0].clientHeight) {
                    
                    jQuery(this).parent().parent().append(create_read_more());
                }
            });
        }, 500);
        
        function create_read_more(){
            let html = "<p class=\"io_review_readmore\" onClick=\"review_readmore_clicked(this)\">read more</p>"
            return html;
        }
        
        function review_readmore_clicked(element){
            let review_li = jQuery(element).parent().find("li:eq(3)");
            new_height = jQuery(review_li).find("p").height() + 16;
            jQuery(review_li).height(new_height);
            jQuery(element).hide();
        }
        
        function io_get_reviews(element){
        let io_un = "' . get_option('io_username') . '";
	  let io_loc = "' . get_option('io_locationid') . '";
	  let io_url1 = \'https://rental.software/testimonials_iframe.php?user=\';
	  if (location.hostname === "localhost"){
	      io_url1 = \'http://localhost/io/bugs/testimonials_iframe.php?user=\';
          //io_url1 = \'http://localhost/jbug/trunk/testimonials_iframe.php?user=\';
        }
	  let io_url2 = \'&location_id=\';
	  let io_url3 = \'&width=100%&number_of_reviews='.$number_of_reviews.'&show_average_rating=1&show_stars=1&show_date=&show_reviewer_name=1&orderby='.$review_order.'&iframe=0\';
	  let io_url_c = io_url1 + io_un + io_url2 + io_loc + io_url3;
	  fetch(io_url_c, {
		method: \'get\'
	}).then(
	  function(response){
		 return response.json();
		}
	).then(function(data) {

    
        
	//let element = document.getElementById("io_testimonials");
	let out = "";
	let review_cnt=0;
	let rating_sum = 0;
	data.forEach((user) => {
				const { name, review, rating, time } = user;
				rating_sum += Number(rating);
				review_cnt++;
				let img_star = Math.round(parseFloat(rating));
				star = `<img class="review_img" src="https://rental.software/images/${img_star}star.png" />`;
				';
    if ($show_review_stars == "off"){
        $html.="star=``;";
    }
    $html.='
				out +=
				`<div>
					<ul class="w3-ul">
						<li '.$show_name_style.'>${name}</li>
						<li>${rating} ${star}</li>
						<li '.$show_date_style.'>${time}</li>
						<li> <p>${review}</p> </li>
					</ul>
				</div>`;
	});
	let avg = (parseFloat(rating_sum)/parseFloat(review_cnt)).toFixed(1);
	let avg_img = Math.round(avg);
	let head = `<div '.$show_average_style.'><h2>Avg Rating: ${avg}</h2><img class="review_avg_img" src="https://rental.software/images/${avg_img}star.png" /></div>`;
	element.innerHTML = head + out;
	return head+out;
	}).catch(function(err) {
		console.log(err);
	});
}
    
	  </script>';
    return $html;
}

function io_add_assets() {
    global $plugin_current_version;
    wp_enqueue_script( 'jquery' );
    wp_enqueue_style( 'io_styles', plugin_dir_url( __FILE__ ) . "io_styles_v6.css" );//WARN: Don't add v=? to URL can cause issues. css combiners detect changes, but we need to still version in case they aren't using one
    wp_enqueue_style('font-awesome', 'https://use.fontawesome.com/releases/v5.12.0/css/all.css');//if elementor installed, this gets skipped
    wp_enqueue_script( 'simpleCart', plugin_dir_url( __FILE__ ) . "simpleCart_v9.js" );


    wp_enqueue_script( 'jquery-ui-core' );
    wp_enqueue_script( 'jquery-ui-dialog' );
    wp_enqueue_script( 'jquery-ui-datepicker' );;
    wp_enqueue_style('datepicker_css', plugin_dir_url( __FILE__ ) . "jquery.datepicker.css" );
    wp_enqueue_script( 'timePicker', plugin_dir_url( __FILE__ ) . "jquery.timepicker.1_8_1.js" );
    wp_enqueue_style( 'timePicker_css', plugin_dir_url( __FILE__ ) . "jquery.timepicker.css" );
    wp_enqueue_script( 'fancyBox', plugin_dir_url( __FILE__ ) . "jquery.fancybox.js" );
    wp_enqueue_script( 'flickity', plugin_dir_url( __FILE__ ) . "flickity.js" );
    wp_enqueue_style( 'fancyBox_css', plugin_dir_url( __FILE__ ) . "jquery.fancybox.css" );
    wp_enqueue_script( 'widget-TentCalcJS', plugin_dir_url( __FILE__ ) . "widget-TentCalculator.js" );

}
function io_add_admin_assets(){
    wp_enqueue_script( 'timePicker', plugin_dir_url( __FILE__ ) . "jquery.timepicker.1_8_1.js" );
    wp_enqueue_style( 'timePicker_css', plugin_dir_url( __FILE__ ) . "jquery.timepicker.css" );
    wp_enqueue_script( 'jquery-ui-core' );
    wp_enqueue_script( 'io_url_protection', plugin_dir_url( __FILE__ ) . "io_url_protection.js" );
    wp_enqueue_script( 'hide_visual_tab_tinymce', plugin_dir_url( __FILE__ ) . "hide_visual_tab_tinymce.js" );
}
add_action( 'admin_footer', 'io_admin_footer' );
function io_admin_footer() {
    $html = '<style>.e-notice--dismissible,.e-notice-bar{display:none}</style>';
    echo $html;
}

if(get_option('io_username')<>'inflatableoffice') {
    add_action('wp_enqueue_scripts', 'io_add_assets');
    add_action('admin_enqueue_scripts', 'io_add_admin_assets');
    /*
    add_action( 'elementor/editor/before_enqueue_scripts', function() {
        wp_enqueue_script( 'hide_visual_tab_tinymce', plugin_dir_url( __FILE__ ) . "hide_visual_tab_tinymce.js" );
    } );
    */
}

add_action( 'wp_head', 'io_add_analytics_code_allpages' );
function io_add_analytics_code_allpages(){
    if(strpos($_SERVER['REQUEST_URI'],'io_')!==FALSE) return;
    $html = '';
    $io_analytics_active = get_option('io_analytics_active');
    if($io_analytics_active==1){
        $html .= get_option('io_analytics_code');
    }
    echo $html;
}



//custom options
function customtheme_customize_register_io( $wp_customize ) {

    $wp_customize->add_section(
        'customtheme_header_options2',
        array(
            'title'       => __( 'IO Plugin Settings', 'customtheme' ),
            'priority'    => 100,
            'capability'  => 'edit_theme_options',
            'description' => __('Change IO plugin options here.', 'customtheme'),
        )
    );
    $wp_customize->add_setting( 'darkmode_enable',
        array(
            'default' => '',
            "transport" => "refresh",
            'sanitize_callback' => 'io_sanitize_checkbox',
        )
    );
    $wp_customize->add_control( new WP_Customize_Control(
        $wp_customize,
        'darkmode_enable_control',
        array(
            'label'    => __( 'Enable Dark Mode', 'customtheme' ),
            'description' => __( 'Warning! Experimental Feature' ),
            'section'  => 'customtheme_header_options2',
            'settings' => 'darkmode_enable',
            'priority' => 10,
            'type'  => 'checkbox',
        )
    ));
    $wp_customize->add_setting( 'iopageext_enable',
        array(
            'default' => '',
            "transport" => "refresh",
            'sanitize_callback' => 'io_sanitize_checkbox',
        )
    );
    $wp_customize->add_control( new WP_Customize_Control(
        $wp_customize,
        'iopageext_enable_control',
        array(
            'label'    => __( 'Enable Extended Feature Mode', 'customtheme' ),
            'description' => __( 'Warning! Experimental Feature' ),
            'section'  => 'customtheme_header_options2',
            'settings' => 'iopageext_enable',
            'priority' => 10,
            'type'  => 'checkbox',
        )
    ));

    function io_sanitize_checkbox( $checked ) {
        return ( ( isset( $checked ) && true == $checked ) ? true : false );
    }
}
//add_action( 'customize_register', 'customtheme_customize_register_io', 11 );

//allows sync of elementor pages via meta tbl
function register_posts_meta_field() {
    $object_type = 'post';
    $args1 = array( // Validate and sanitize the meta value.
        // Note: currently (4.7) one of 'string', 'boolean', 'integer',
        // 'number' must be used as 'type'. The default is 'string'.
        'type'         => 'string',
        // Shown in the schema for the meta key.
        'description'  => 'A meta key associated with a string meta value.',
        // Return a single value of the type.
        'single'       => true,
        // Show in the WP REST API response. Default: false.
        'show_in_rest' => true,
        'auth_callback' => function() {
            return current_user_can( 'edit_posts' );
        },
    );
    register_meta( $object_type, '_elementor_data', $args1 );
    register_meta( $object_type, 'io_meta_description', $args1 );
}
add_action( 'rest_api_init', 'register_posts_meta_field' );


//allows sync of analytics code (or any option)
function register_site_options() {
    register_rest_route( 'inflatableoffice/v1', '/options/(?P<id>[-_a-zA-Z0-9-]+)', array(
        'methods' => 'GET,POST',
        'callback' => 'io_options',
        'permission_callback' => function() {
            return current_user_can( 'edit_posts' );
            //     return true;
        },
    ) );
}
function io_options($data) {
    if($data->get_method()=='POST'){
        if($data['id']=='io_cart_time_format'){
            //$value = get_option($data['id']);
            //so we only run this if it's changed, but okay to run it every time
            //if($value<>$data->get_body()){
            //convert times. the sync handles this as well for start/end but not for the other time fields
            //it's good to have it in both places in case they aren't using newer plugin that has this
            $time = date($data->get_body(), strtotime(get_option('io_default_start_time')));
            update_option('io_default_start_time', $time);
            $time = date($data->get_body(), strtotime(get_option('io_default_end_time')));
            update_option('io_default_end_time', $time);
            $time = date($data->get_body(), strtotime(get_option('io_overnightPickupTime')));
            update_option('io_overnightPickupTime', $time);
            $time = date($data->get_body(), strtotime(get_option('io_restrictTimeStart')));
            update_option('io_restrictTimeStart', $time);
            $time = date($data->get_body(), strtotime(get_option('io_restrictTimeEnd')));
            update_option('io_restrictTimeEnd', $time);
            //}
        }
        update_option($data['id'],$data->get_body());
    }
    $value = get_option($data['id']);
    return $value;
}

add_action( 'rest_api_init', 'register_site_options' );

add_action('TentCalcSubmit', function(){
   $thing = 1;
});

//add to the submit of the elementor form to call our contact us page
add_action( 'elementor_pro/forms/new_record', "io_handle_elementor_form_submit", 10, 3);
function io_handle_elementor_form_submit($record, $handler){
    $io_makeLeadsOnForms = get_option('io_makeLeadsOnForms');
    $io_excludeforms = get_option('io_excludeforms');
    $io_excludeforms_arr = array_map('trim', explode(',', $io_excludeforms));

    if($io_makeLeadsOnForms == 'on'){
        $form_name = $record->get_form_settings( 'form_name' );
        if(in_array($form_name,$io_excludeforms_arr)) return;
        $io_pagename = get_option('io_pagename');
        $page_name = urlencode($io_pagename);//'Demo+Rentals+LLC';
        $page_name = '&name='.$page_name;
        $params = '&elemCTA=1';
        if(isset($_COOKIE['adwords'])) $params.='&adwords='.$_COOKIE['adwords'];
        if(isset($_COOKIE['facebook'])) $params.='&facebook='.$_COOKIE['facebook'];

        $cust_ip = $_SERVER['REMOTE_ADDR'];
        if(!empty($_SERVER['HTTP_CLIENT_IP'])) $cust_ip = $_SERVER['HTTP_CLIENT_IP'];
        if(!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) $cust_ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
        if(!empty($_SERVER['HTTP_X_SUCURI_CLIENTIP'])) $cust_ip = $_SERVER['HTTP_X_SUCURI_CLIENTIP'];
        $ips = explode(',', $cust_ip, 2);
        $cust_ip = urlencode(trim($ips[0]));
        if(strpos($params,'&io_custip=')===FALSE) $params.='&io_custip='.$cust_ip;
        if(isset($_COOKIE['guid']) && strpos($params,'&io_custguid=')===FALSE) $params.='&io_custguid='.$_COOKIE['guid'];

        $link = 'https://rental.software/quotes/contactme.php?nowrap=1'.$page_name.$params;
        $fields = Array();
        $raw_fields = $record->get( 'fields' );
        foreach ($raw_fields as $k=>$v){
            if($k=='name') $k='firstandlastname';
            if($k=='message') $k='notes';
            if($v['type']=='html') continue;
            if(strpos($k,'customfield_')!==FALSE) $k=str_replace('customfield_','customfield-',$k);
            $v = trim($v["value"]);

            //non-standard fields will additionally get appended to the notes
            // setupduration
            if(!in_array($k,Array('okToTextPresent','oktotext','startdate','starttime','enddate','endtime','taxexempt','eventname','salesrep','eventstreet','eventzip','eventcity','eventstate','deliverytype', 'street','zip','state','city','officephone','custtags','oktotext','firstandlastname','cellphone','email','firstname','lastname','eventorganization','notes','title', 'attachment', 'surface')) && strpos($k,'customfield-')===FALSE){
                $fields['notes'] .= "\n".$k.': '.$v;
            }

            $fields[$k] .= $v;
        }
        $fields['notes'] = trim($fields['notes']);
        $fields['from_wp'] = 1;
        //$fields['notes'].="\nPage URL: ".$_POST['referrer'];

        $result = wp_safe_remote_post( $link, [
            'body' => $fields,
            'timeout' => 20
        ]);
        $result = json_decode($result['body']);
        if($result->redirect_url && empty($record->get_form_settings('redirect_to'))){
            $handler->add_response_data( 'redirect_url', $result->redirect_url );
        }
        //echo $result;
    }
}

//prevent sg optimizer from combining our js files otherwise it screws up the quote page (if that option is turned on)
add_filter( 'sgo_javascript_combine_exclude_all_inline', '__return_true' );
add_filter( 'sgo_javascript_combine_excluded_external_paths', 'js_combine_exclude_external_script' );
function js_combine_exclude_external_script( $exclude_list ) {
    $exclude_list[] = 'rental.software';

    return $exclude_list;
}

add_action("add_meta_boxes", "add_custom_meta_box");
function add_custom_meta_box(){
    add_meta_box("demo-meta-box", "InflatableOffice", "custom_meta_box_markup", "page", "side", "high", null);
}

function custom_meta_box_markup($object){
    wp_nonce_field(basename(__FILE__), "meta-box-nonce");
    $checkbox_value = get_post_meta($object->ID, "io-include-featured", true);

    if($checkbox_value == "")
    {
        ?>
        <input name="io-include-featured" type="checkbox" value="true">
        <label>Make this page selectable in IO Featured Product Widget</label>
        <?php
    }
    else if($checkbox_value == "true")
    {
        ?>
        <input name="io-include-featured" type="checkbox" value="true" checked>
        <label>Make this page selectable in IO Featured Product Widget</label>
        <?php
    }
}
add_action("save_post", "save_custom_meta_box", 10, 3);
function save_custom_meta_box($post_id, $post, $update)
{
    if (!isset($_POST["meta-box-nonce"]) || !wp_verify_nonce($_POST["meta-box-nonce"], basename(__FILE__)))
        return $post_id;

    if(!current_user_can("edit_post", $post_id))
        return $post_id;

    if(defined("DOING_AUTOSAVE") && DOING_AUTOSAVE)
        return $post_id;

    $slug = "page";
    if($slug != $post->post_type)
        return $post_id;

    $meta_box_checkbox_value = "";

    if(isset($_POST["io-include-featured"]))
    {
        $meta_box_checkbox_value = $_POST["io-include-featured"];
    }
    update_post_meta($post_id, "io-include-featured", $meta_box_checkbox_value);
}

/* IO-14955: get/set option in wp_options */
function register_social_api() {
    register_rest_route( 'inflatableoffice/v1', '/social_posts/(?P<id>[-_a-zA-Z0-9-]+)', array(
        'methods' => 'POST',
        'callback' => 'io_social_posts'
    ) );
}

/**
 * The call back for when the REST endpoint for marketing posts gets hit
 * $data['id'] = 'wp_options' table => 'option_name' field
 * @param $data
 * @return mixed
 */
function io_social_posts(WP_REST_Request $request) {

//Route data based on optionName param
    $params = $request->get_params();
    $optionName = urldecode($params['optionName']);

    switch($optionName) {
        case "io_gmb_access":

            require_once(dirname(__FILE__) . '/social_api_factory.php');

            $data = array(
                'option_name' => $optionName,
                'site_url'=> urldecode($params['siteURL']),
                'rental_name' => urldecode($params['rentalName']),
                'rental_description' => urldecode($params['rentalDescription']),
                'rental_image' => urldecode($params['rentalImage']),
                'rental_url' => urldecode($params['rentalURL']),
                'category_name' => urldecode($params['categoryName']),
                'category_description' => urldecode($params['categoryDescription']),
                'category_image' => urldecode($params['categoryImage']),
                'category_url' => urldecode($params['categoryURL']),
            );

            //logging
            if (! update_option('io_gmb_rest_params', json_encode($data))){
                add_option('io_gmb_rest_params', json_encode($data));
            }

            $gmb = social_api_factory::create("GoogleMyBusiness");

            return $gmb->createPost($data);
    }

}
add_action('rest_api_init', 'register_social_api');

add_filter('autoptimize_filter_noptimize','stop_autoptimize_on_quote_page',10,1);
function stop_autoptimize_on_quote_page($flag) {
    if (strpos($_SERVER['REQUEST_URI'],'io_')!== false) {
        return true;
    } else {
        return $flag;
    }
}


add_filter( 'sgs_whitelist_wp_content' , 'whitelist_filter_file_in_wp_content' );
function whitelist_filter_file_in_wp_content( $whitelist ) {
    $whitelist[] = 'website_filter.php';
    $whitelist[] = 'TentCalcSubmit.php';
    $whitelist[] = 'login.php';
    return $whitelist;
}

function io_get_variable($atts){
    return $_GET[$atts['name']];
}
add_shortcode( 'io_get_variable', 'io_get_variable');
